package it.unibo.stradivarius.notifyme;

import android.app.Service;
import android.content.Intent;
import android.os.Binder;
import android.os.IBinder;
import android.util.Log;

import androidx.core.app.NotificationCompat;
import androidx.core.app.NotificationManagerCompat;

import java.util.Calendar;

public class BoundService extends Service {
    // Binder given to clients
    private final IBinder sBinder = (IBinder) new SimpleBinder();

    @Override
    public IBinder onBind(Intent arg0) {
        Log.v("SERVICES","BIND");
        return sBinder;
    }

    class SimpleBinder extends Binder {
        BoundService getService() {
            return BoundService.this;
        }
    }

    public void getDate() {
        Log.v("SERVICES","SENDING DATE NOTIFICATION");
        Calendar cal= Calendar.getInstance();
        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        NotificationCompat.Builder mBuilder = new NotificationCompat.Builder(this, "notificationServiceChannel");
        mBuilder.setContentTitle("Time now is")
                .setContentText(cal.getTime().toString())
                .setSmallIcon(R.mipmap.ic_launcher_round)
                .setPriority(NotificationCompat.PRIORITY_LOW);
        notificationManager.notify(66,mBuilder.build());
    }

}
