package it.unibo.stradivarius.notifyme;

import android.app.IntentService;
import android.content.Intent;
import android.media.RingtoneManager;

import androidx.core.app.NotificationCompat;
import androidx.core.app.NotificationManagerCompat;

public class MyIntentService extends IntentService {

    public MyIntentService() {
        super("MyIntentService");
    }

    @Override
    protected void onHandleIntent(Intent intent) {
        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        NotificationCompat.Builder mBuilder = new NotificationCompat.Builder(this, "notificationServiceChannel");
        mBuilder.setContentTitle("Download")
                .setContentText("Download in progress")
                .setSmallIcon(R.mipmap.ic_launcher_round)
                .setPriority(NotificationCompat.PRIORITY_LOW);

        int PROGRESS_MAX = 100;
        int PROGRESS_CURRENT = 0;
        mBuilder.setProgress(PROGRESS_MAX, PROGRESS_CURRENT, false);
        notificationManager.notify(99, mBuilder.build());

        int i = 0;
        while (i < PROGRESS_MAX) {
            mBuilder.setProgress(PROGRESS_MAX, i, false);
            notificationManager.notify(99, mBuilder.build());
            i++;
            try {
                Thread.sleep(50);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

        long[] l = {100,2000,100,2000};
        mBuilder.setContentText("End").setProgress(0,0,false)
                .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
                .setLights(0xff00ff00, 3000, 100)
                .setVibrate(l);

        notificationManager.notify(99, mBuilder.build());
    }
}